@use crate::home_page::HomeCategory;
@use crate::Urler;
@use crate::iter::*;

@(cats: &[HomeCategory], url: &Urler, toplevel: bool)

    @for cat in cats {
        <li>
        <div>
            <a href="@url.category(&cat.cat)">@if toplevel {
                <h3>@cat.cat.standalone_name()</h3>
            } else {
                <h4>@cat.cat.standalone_name()</h4>
            }
            <span class=desc>@cat.cat.short_description</span>
            </a>
        </div>
            <ul class=crates>
            @for t in &cat.top {
                <li>
                    <a href="@url.krate(t)" title="@t.description().unwrap_or("")"
                    >@for (last, part) in t.short_name().split('_').identify_last() {@part@if !last {_<wbr>}}</a></li>
            }
            @if cat.pop.saturating_sub(cat.top.len()) > 2 {
                <li>and <a class="more" href="@url.category(&cat.cat)">@(cat.pop - cat.top.len()) more…</a></li>
            }
            </ul>
        </li>
        @if !cat.sub.is_empty() {
            @:home_categories(&cat.sub, url, false)
        }
    }

